/*
	AWCodeX.c

	junk.

2005
A.P.:
	March 11
		Creation.
*/

#define _AWCODEX_C

#include "macintosh_cseries.h"

#include "shell.h"
#include "interface.h"

#include "AWCodeX.h"

/* prototypes */

static void handle_xproc_callback(AWCodeXParam *param);

/* code */

#ifdef env68k
# undef NewAWCodeXUPP
# undef DisposeAWCodeXUPP
# define NewAWCodeXUPP(x)					x
# define DisposeAWCodeXUPP(x)
# define AWCodeXUPP							AWCodeXProcPtr
#endif

#define prepare_resource_handle(h,s)		\
	if(h==NULL) {err=ResError(); goto end;}	\
	s = HGetState(h);						\
	if(err=MemError()) goto end;			\
	HLock(h);								\
	if(err=MemError()) goto end;

#define call_xproc(r,p,f,c)					\
	memset(p,0,sizeof(AWCodeXParam));		\
	(p)->paramFlags = f, (p)->callback = c;	\
	InvokeAWCodeXUPP(p,r);

static AWCodeXParam		local_xparam;

int call_xproc_resource(SInt16 id, UInt32 flags)
{
	register AWCodeXUPP			callback = NewAWCodeXUPP(handle_xproc_callback);
	register AWCodeXUPP			proc;

	Handle				h;
	OSErr				err;
	Byte				hstate;
Debugger();
	if (callback==NULL)
	{
		err = MemError();
		goto end;
	}
#ifdef mac
# ifdef envppc
	if (h=GetResource(AWCodeX_PPCResourceType,id))
	{
		prepare_resource_handle(h,hstate);
		proc = (AWCodeXUPP)NewRoutineDescriptor((ProcPtr)*h,uppAWCodeXRoutineInfo,kPowerPCISA)
	} else
	{
		h = GetResource(AWCodeX_68KResourceType,id);
		prepare_resource_handle(h,hstate);
		proc = (AWCodeXUPP)NewRoutineDescriptor((ProcPtr)*h,uppAWCodeXRoutineInfo,kM68kISA)
	}
# else
	h = GetResource(AWCodeX_68KResourceType,id);
	prepare_resource_handle(h,hstate);
	proc = (AWCodeXUPP)*h;
# endif
#endif
	call_xproc(proc,&local_xparam,flags,callback);

	DisposeAWCodeXUPP(proc);
	DisposeAWCodeXUPP(callback);
#ifdef mac
	HSetState(h,hstate);
#endif
end:
	return err;
}

int call_xproc_resource_by_name(ConstStr255Param name, UInt32 flags)
{
	register AWCodeXUPP		callback = NewAWCodeXUPP(handle_xproc_callback);
	register AWCodeXUPP		proc;

	Handle				h;
	OSErr				err;
	Byte				hstate;
Debugger();
	if (callback==NULL)
	{
		err = MemError();
		goto end;
	}
#ifdef mac
# ifdef envppc
	if (h=GetNamedResource(AWCodeX_PPCResourceType,name))
	{
		prepare_resource_handle(h,hstate);
		proc = (AWCodeXUPP)NewRoutineDescriptor((ProcPtr)*h,uppAWCodeXRoutineInfo,kPowerPCISA)
	} else
	{
		h = GetNamedResource(AWCodeX_68KResourceType,name);
		prepare_resource_handle(h,hstate);
		proc = (AWCodeXUPP)NewRoutineDescriptor((ProcPtr)*h,uppAWCodeXRoutineInfo,kM68kISA)
	}
# else
	local_xparam.callback = handle_xproc_callback;
	h = GetNamedResource(AWCodeX_68KResourceType,name);
	prepare_resource_handle(h,hstate);
	proc = (AWCodeXUPP)*h;
# endif
#endif
	call_xproc(proc,&local_xparam,flags,callback);

	DisposeAWCodeXUPP(callback);
#ifdef mac
	HSetState(h,hstate);
#endif
end:
	return err;
}

#include "myDialogs.h"

static void handle_xproc_callback(AWCodeXParam *param)
{
	void		*misc = (void*)Native64Ptr(param->callbackParams[0]);
	long		temp, temp2;

	switch(param->callbackType)
	{
	case kAWX_memchr:
		Native64Ptr(param->result) = memchr(misc,Native64Int(param->callbackParams[1]),
			Native64Int(param->callbackParams[2]));
		break;
	case kAWX_memcmp:
		Native64Int(param->result) = memcmp(misc,Native64Ptr(param->callbackParams[1]),
			Native64Int(param->callbackParams[2]));
		break;
	case kAWX_memset:
		memset(misc,Native64Int(param->callbackParams[1]),Native64Int(param->callbackParams[2]));
		break;
	case kAWX_memcpy:
		memcpy(misc,Native64Ptr(param->callbackParams[1]),Native64Int(param->callbackParams[2]));
		break;
	case kAWX_memmove:
		memmove(misc,Native64Ptr(param->callbackParams[1]),Native64Int(param->callbackParams[2]));
		break;
	case kAWX_memcnt:
		Native64Int(param->result) = memcnt(misc,Native64Int(param->callbackParams[1]),
			Native64Int(param->callbackParams[2]));
		break;

	case kAWX_c2p:
		break;
	case kAWX_p2c:
		break;

	case kAWX_strchr:
		Native64Ptr(param->result) = strchr(misc,Native64Int(param->callbackParams[1]));
		break;
	case kAWX_strcmp:
		Native64Int(param->result) = strcmp(misc,Native64Ptr(param->callbackParams[1]));
		break;
	case kAWX_strncmp:
//		Native64Int(param->result) = strncmp(misc,Native64Ptr(param->callbackParams[1]),
//			Native64Int(param->callbackParams[2]));
		break;
	case kAWX_strcpy:
	case kAWX_strncpy:
	case kAWX_strcat:
	case kAWX_strncat:
	case kAWX_strrchr:

	case kAWX_strlen:
		Native64Int(param->result) = strlen(misc);
		break;
	case kAWX_strcoll:
	case kAWX_strxfrm:
	case kAWX_strcspn:
	case kAWX_strpbrk:
	case kAWX_strspn:
	case kAWX_strstr:
	case kAWX_strtok:
	case kAWX_strucmp:
	case kAWX_strcnt:
		break;

	case kAWX_atoi:
		Native64Int(param->result) = atoi(misc);
		break;
	case kAWX_atol:
	case kAWX_atof:
		break;

	case kAWX_rand:
		Native64Int(param->result) = rand();
		break;
	case kAWX_lrand:
		temp = rand()<<8,	temp2 = rand()<<8;
		temp ^= rand()<<20, temp2 ^= rand()<<20;
		temp ^= rand(),		temp2 ^= rand();
		SetInt64(param->result,temp,temp2);
		break;
	case kAWX_frand:
		break;

	case kAWX_free:
		free(misc);
		break;
	case kAWX_malloc:
		Native64Ptr(param->result) = realloc(NULL,(long)misc);
		break;
	case kAWX_calloc:
		Native64Ptr(param->result) = calloc((long)misc,Native64Int(param->callbackParams[1]));
		break;
	case kAWX_realloc:
		Native64Ptr(param->result) = realloc(misc,Native64Int(param->callbackParams[1]));
		break;
	case kAWX_rmalloc:
		Native64Ptr(param->result) = rmalloc(misc,Native64Int(param->callbackParams[1]));
		break;
	case kAWX_tmalloc:
		Native64Ptr(param->result) = tmalloc((long)misc);
		break;

	case kAWX_dprintf:
		dprintf((const char*)misc,Native64Ptr(param->callbackParams[1]),
			Native64Ptr(param->callbackParams[2]),Native64Ptr(param->callbackParams[3]),
			Native64Ptr(param->callbackParams[4]),Native64Ptr(param->callbackParams[5]),
			Native64Ptr(param->callbackParams[6]),Native64Ptr(param->callbackParams[7]),
			Native64Ptr(param->callbackParams[8]),Native64Ptr(param->callbackParams[9]),
			Native64Ptr(param->callbackParams[10]),Native64Ptr(param->callbackParams[11]),
			Native64Ptr(param->callbackParams[12]),Native64Ptr(param->callbackParams[13]),
			Native64Ptr(param->callbackParams[14]));
		break;
	case kAWX_csprintf:
		csprintf((char*)misc,(const char*)Native64Ptr(param->callbackParams[1]),
			Native64Ptr(param->callbackParams[2]),Native64Ptr(param->callbackParams[3]),
			Native64Ptr(param->callbackParams[4]),Native64Ptr(param->callbackParams[5]),
			Native64Ptr(param->callbackParams[6]),Native64Ptr(param->callbackParams[7]),
			Native64Ptr(param->callbackParams[8]),Native64Ptr(param->callbackParams[9]),
			Native64Ptr(param->callbackParams[10]),Native64Ptr(param->callbackParams[11]),
			Native64Ptr(param->callbackParams[12]),Native64Ptr(param->callbackParams[13]),
			Native64Ptr(param->callbackParams[14]));
		break;
	case kAWX_psprintf:
		psprintf((char*)misc,(const char*)Native64Ptr(param->callbackParams[1]),
			Native64Ptr(param->callbackParams[2]),Native64Ptr(param->callbackParams[3]),
			Native64Ptr(param->callbackParams[4]),Native64Ptr(param->callbackParams[5]),
			Native64Ptr(param->callbackParams[6]),Native64Ptr(param->callbackParams[7]),
			Native64Ptr(param->callbackParams[8]),Native64Ptr(param->callbackParams[9]),
			Native64Ptr(param->callbackParams[10]),Native64Ptr(param->callbackParams[11]),
			Native64Ptr(param->callbackParams[12]),Native64Ptr(param->callbackParams[13]),
			Native64Ptr(param->callbackParams[14]));
		break;
	case kAWX_cscanf:
	case kAWX_pscanf:
		break;

	case kAWX_qsort:
	case kAWX_xqsort:
		break;

	case kAWX_GetProgramVariables:
		Native64Ptr(param->result) = (void*)&temporary;
		break;
	case kAWX_SetOverheadBoxText:
		SetOverheadBoxText((const char*)misc);
		break;
	case kAWX_HandleProgramEvent:
		HandleEvent((DialogRef)misc,(EventRecord*)Native64Ptr(param->callbackParams[1]),
			param->requestFlags & kAWXInterfaceHalted,param->requestFlags & kAWXPassToCaller);
		break;
	case kAWX_LSelectAll:
		LSelectAll((Boolean)misc,(ListHandle)Native64Ptr(param->callbackParams[1]));
		break;
	case kAWX_AnimateDialogButton:
		animate_dialog_button((DialogRef)misc,Native64Int(param->callbackParams[1]));
		break;
	case kAWX_ListDlg:
		Native64Int(param->result) = ListDialog((cs_fontspec*)misc,
			(UInt8*)Native64Ptr(param->callbackParams[1]),(char*)Native64Ptr(param->callbackParams[2]),
			Native64Int(param->callbackParams[3]),Native64Int(param->callbackParams[4]),
			(list_spec_data*)Native64Ptr(param->callbackParams[5]),(SInt16*)Native64Ptr(param->callbackParams[6]),
			(SInt16*)Native64Ptr(param->callbackParams[7]));
	}
}
