
#define AWCodeX_68KResourceType			'XPRC'
#define AWCodeX_PPCResourceType			'xprc'

enum
{
 /* paramFlags/requestFlags */
	kAWXParamCountMask		= 15,		/* applies to all `flags' parameters */
	kAWXParamDisplay		= 0x80,		/* otherwise, caller is requesting no display during operation */
	kAWXInterfaceHalted		= 0x40,		/* user is forced to wait during operation */
	kAWXPassToCaller		= 0x20		/* continue with the affected data */
};

typedef CALLBACK_API_C(void,AWCodeXProcPtr)(struct AWCodeXParam *param);
typedef STACK_UPP_TYPE(AWCodeXProcPtr)		AWCodeXUPP;

EXTERN_API_C( AWCodeXUPP )
NewAWCodeXUPP(AWCodeXProcPtr userRoutine);
#if !OPAQUE_UPP_TYPES
  enum { uppAWCodeXRoutineInfo = 0x000000C1 };	/* no_return_value Func(4_bytes) */
# ifdef __cplusplus
   inline AWCodeXUPP NewAWCodeXUPP(AWCodeXProcPtr userRoutine) { return (AWCodeXUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppAWCodeXRoutineInfo,GetCurrentArchitecture()); }
# else
#  define NewAWCodeXUPP(userRoutine) (AWCodeXUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppAWCodeXRoutineInfo,GetCurrentArchitecture())
# endif
#endif

EXTERN_API_C( void )
DisposeAWCodeXUPP(AWCodeXUPP userUPP);
#if !OPAQUE_UPP_TYPES
# ifdef __cplusplus
   inline void DisposeAWCodeXUPP(AWCodeXUPP userUPP) { DisposeRoutineDescriptor((UniversalProcPtr)userUPP); }
# else
#  define DisposeAWCodeXUPP(userUPP) DisposeRoutineDescriptor(userUPP)
# endif
#endif

EXTERN_API_C( void )
InvokeAWCodeXUPP(struct AWCodeXParam *param, AWCodeXUPP userUPP);
#if !OPAQUE_UPP_TYPES
# ifdef __cplusplus
   inline void InvokeAWCodeXUPP(struct AWCodeXParam *param, AWCodeXUPP userUPP) { CALL_ONE_PARAMETER_UPP(userUPP,uppAWCodeXRoutineInfo,param); }
# else
#  define InvokeAWCodeXUPP(param,userUPP) CALL_ONE_PARAMETER_UPP((userUPP),uppAWCodeXRoutineInfo,(param))
# endif
#endif

#if TYPE_LONGLONG
# define Native64Ptr(x)					(*(void**)&(x))
# define Native64Int(x)					((SInt32)x)
#else
# define Native64Ptr(x)					(*(void**)&(x).lo)
# define Native64Int(x)					(x).lo
#endif

typedef struct AWCodeXParam
{
	UInt64			result, params[15], callbackParams[6];
	UInt32			paramFlags, responseFlags;
	UInt16			paramType, callbackType;
	UInt32			requestFlags;

	AWCodeXUPP		callback;
} AWCodeXParam, *AWCodeXParamPtr;

enum
{
	kAWX_memchr					= 0,
	kAWX_memcmp					= 1,
	kAWX_memset					= 2,
	kAWX_memcpy					= 3,	/*kAWX_memccpy				= 4,*/
	kAWX_memmove				= 4,
	kAWX_memcnt					= 5,	/* character count */

	kAWX_c2p					= 6,
	kAWX_p2c					= 7,

	kAWX_strchr					= 8,
	kAWX_strcmp					= 9,
	kAWX_strncmp				= 10,
	kAWX_strcpy					= 11,
	kAWX_strncpy				= 12,
	kAWX_strcat					= 13,
	kAWX_strncat				= 14,
	kAWX_strrchr				= 15,

	kAWX_strlen					= 16,
	kAWX_strcoll				= 17,
	kAWX_strxfrm				= 18,
	kAWX_strcspn				= 19,
	kAWX_strpbrk				= 20,
	kAWX_strspn					= 21,
	kAWX_strstr					= 22,
	kAWX_strtok					= 23,
	kAWX_strucmp				= 24,	/* case insensitive comparison */
	kAWX_strcnt					= 25,	/* character count */

	kAWX_atoi					= 26,	/* -> 32 bit */
	kAWX_atol					= 27,	/* -> 64 bit */
	kAWX_atof					= 28,	/* -> 64 bit -- floating point */

	kAWX_rand					= 29,	/* -> 15 bit */
	kAWX_lrand					= 30,	/* -> 64 bit */
	kAWX_frand					= 31,	/* -> 64 bit -- floating point [0,1] */

	kAWX_free					= 32,
	kAWX_malloc					= 33,
	kAWX_calloc					= 34,
	kAWX_realloc				= 35,
	kAWX_rmalloc				= 36,	/* resize set relocate (data is saved) */
	kAWX_tmalloc				= 37,	/* transitional allocation (stuff may be disposed) */

	kAWX_dprintf				= 40,	/* for debugging */
	kAWX_csprintf				= 41,	/* C-String printf */
	kAWX_psprintf				= 42,	/* Pascal-String printf */
	kAWX_cscanf					= 43,	/* C-String scanf */
	kAWX_pscanf					= 44,	/* Pascal-String scanf */

	kAWX_qsort					= 48,
	kAWX_xqsort					= 49,	/* _qsort */

	kAWX_GetProgramVariables	= 64,
	kAWX_SetOverheadBoxText		= 65,
	kAWX_HandleProgramEvent		= 66,
	kAWX_LSelectAll				= 67,
	kAWX_AnimateDialogButton	= 68,
	kAWX_ListDlg				= 69
};

/*  PUBLIC END  */
/* the code starting at the previous line is not released in the public header */

/* Also see WindowReferencing.h */

int call_xproc_resource(SInt16 id, UInt32 flags);
int call_xproc_resource_by_name(ConstStr255Param name, UInt32 flags);
