
#include "macintosh_cseries.h"

#include <Appearance.h>

#include "myDocument.h"

#include "shell.h"
#include "interface.h"

#include "ae.h"

//#include "AWCodeX.h"

void startup(Boolean display);

/* globals */

Boolean		AERecording;
AEDesc		selfPsnDesc = {typeNull};

extern Boolean				gDone;
extern StandardFileReply	selectedFile;

/*
	code addapted from the MPW example CFMExamples:ModApp:AppleEventHandlers.c
	 by Richard Clark,  1993 by Apple Computer, Inc., all rights reserved.
*/

static pascal OSErr HandleQuit(AEDescList*, AEDescList *reply, long refCon);
static pascal OSErr HandleOapp(AEDescList*, AEDescList *reply, long refCon);
static pascal OSErr HandleOdoc(AEDescList*, AEDescList *reply, long refCon);
static pascal OSErr HandlePdoc(AEDescList*, AEDescList *reply, long refCon);

static OSErr required_appleevent_check(AppleEvent*);

#ifndef NewEventHandlerProc
	#define NewEventHandlerProc(x) (EventHandlerProcPtr)x
#endif

void FatalErrorAE()
{
	alert_user(fatalError,strERRORS,unexpectedError,errAEEventNotHandled);
}

static void wait_for_highlevel_event()
{
	EventRecord		event;
	boolean			done = FALSE;

	while(1)
		if (WaitNextEvent(highLevelEventMask,&event,0,NULL))
		{
			AEProcessAppleEvent(&event);
			break;
		}
}

void install_apple_event_handlers()
{
	OSErr		err;
	long		result;

	if (!(err=Gestalt(gestaltAppleEventsAttr,&result)))
	{
		err = AEInstallEventHandler(kCoreEventClass,kAEOpenApplication,NewAEEventHandlerProc(HandleOapp),0,false);
		err = AEInstallEventHandler(kCoreEventClass,kAEOpenDocuments,NewAEEventHandlerProc(HandleOdoc),0,false);
		err = AEInstallEventHandler(kCoreEventClass,kAEPrintDocuments,NewAEEventHandlerProc(HandlePdoc),0,false);
		err = AEInstallEventHandler(kCoreEventClass,kAEQuitApplication,NewAEEventHandlerProc(HandleQuit),0,false);
		//err = AEInstallEventHandler(kAppearanceEventClass,kAEAppearanceChanged,NewAEEventHandlerProc(HandleApprChange),0,false);
	}
} /* init_apple_events_hook */

pascal OSErr HandleOapp(AEDescList *aevt, AEDescList *reply, long refCon)
{
	#pragma unused (reply, refCon)
	OSErr	err;

	if (err=required_appleevent_check(aevt)) return err;

	//call_xproc_resource_by_name("\pstartup",kAWXParamDisplay);
	startup(true);
	return noErr;
}

pascal OSErr HandleOdoc(AEDescList *aevt, AEDescList *reply, long refCon)
{
	#pragma unused (reply, refCon)
	AEDesc			fileListDesc = {'NULL', NULL};
	long			numFiles, actualSize, index;
	DescType		actualType;
	AEKeyword		actualKeyword;
	OSErr			err;

	/*
		The odoc and pdoc messages contain a list of aliases as the direct
		paramater.  This means that well need to extract the list, count the lists
		elements, and then process each file in turn.
	*/

	/* Extract the list of aliases into fileListDesc */
	if (err=AEGetKeyDesc(aevt,keyDirectObject,typeAEList,&fileListDesc)) goto end;

	if (err=required_appleevent_check(aevt)) goto end;

	/* Count the list elements */
	if (err=AECountItems(&fileListDesc,&numFiles)) goto end;

	/*
		Now, get each file from the list and process it.
		Even though the event contains a list of alises, the Apple Event Manager
			will convert each alias to an FSSpec if we ask it to.
	*/
	for(index=1; index<=numFiles; index++)
	{
		if (err=AEGetNthPtr(&fileListDesc,index,typeFSS,&actualKeyword,
				&actualType,(Ptr)&selectedFile.sfFile,sizeof(selectedFile.sfFile),
				&actualSize))
			goto end;
		OpenDoc(FALSE);
	}
end:
	(void)AEDisposeDesc(&fileListDesc);
	return err;
}

pascal OSErr HandlePdoc(AEDescList *aevt, AEDescList *reply, long refCon)
{
#pragma unused (aevt, reply, refCon)
	/* if you want printing, just add the necessary code and change the
		returned error to noErr when youre done */
	return errAEEventNotHandled;
}

pascal OSErr HandleQuit(AEDescList *aevt, AEDescList *reply, long refCon)
{
#pragma unused (aevt, reply, refCon)
	OSErr	err;

	if (err=required_appleevent_check(aevt)) return err;
	if (CloseDoc(kAllDocuments)) gDone = -1;
	return noErr;
}

static OSErr required_appleevent_check(AppleEvent *event)
{
	OSErr err;
	DescType typeCode;
	Size actualSize;
	
	err = AEGetAttributePtr(event,keyMissedKeywordAttr,typeWildCard,&typeCode,0l,0,&actualSize);
		
	if (err==errAEDescNotFound) return noErr;
	if (err==noErr) return (errAEEventNotHandled);

	return err;
}
