
#ifndef __FORMAT_RECOGNITION_H
# define __FORMAT_RECOGNITION_H

# if !defined(rez) && !defined(derez)
   typedef struct scanned_block /* (16) */
   {
      void				*data;
      SInt64			offset;
      UInt32			length;
   } scanned_block;

   typedef struct file_data_preview
   {
      UInt32			flags;
      SInt32			block_count;
      UInt64			eof;
      scanned_block	scan[1];	/* terminated by a NULL pointer */
   } file_data_preview;

 //#define FDP_SET_EOF(d,s) ((d)->eof[0]=Int64Hi(s),*(UInt32*)&(d)->eof[1]=Int64Lo(s))
 //#define FDP_GET_EOF(d,s) SetInt64((d),(s)->eof[0],*(UInt32*)&(s)->eof[1])

   typedef struct format_spot
   {
      SInt32			offset;
      UInt8				logic, filter, function, data[1];
   } format_spot;

   typedef struct format_identification
   {
      SInt32			spot_count;
      char				data[1];
     /*format_spot spot[1];*/
   } format_id_rec;

   typedef struct format_id_list
   {
      SInt32			count;
      format_id_rec		format_id_list[1];
   } format_id_list;

 /* prototypes */

  /* returns an offset into the format list */
   SInt32 identify_format(file_data_preview *file, format_id_list *formats);

# else

   type 'frLs'
   {
	longint = 0;							/* version */
	longint = $$Countof(FormatIDSpec)-1;
	wide array FormatIDSpec
	{
/*	SpotSpecStart:*/
		string[8];							/* format identifier */
		cstring;							/* list item printf formating */
		longint = $$Countof(SpotSpec)-1;
		wide array SpotSpec
		{
			longint;						/* offset */
			byte;							/* logic */
			byte;							/* filter */
			byte;							/* function */
			pstring;						/* data */
		};
		align word;
	};
   };

   resource 'TMPL' (128,"frLs")
   {
	{
		"Version", 'HLNG',
		"this sucks", 'DWRD',
		"#Formats", 'ZCNT',
		"*****", 'LSTC',
		"Name", 'H008',
		"List Format", 'CSTR',
	/*	"set to zero after making changes", 'DLNG', */
		"it sucks", 'DWRD',
		"#Spots", 'ZCNT',
		"*****", 'LSTC',
		"Offset", 'HLNG',
		"Logic OARNEXT", 'DBYT',
		"Filter", 'HBYT',
		"Function", 'HBYT',
		"Data", 'PSTR',
		"", 'LSTE',
		"", 'LSTE',
	}
   };
# endif	/* !rez */

/* first spot must always be none */
# define kSpotLogic_none					0
# define kSpotLogic_OR						1
# define kSpotLogic_AND						2
# define kSpotLogic_EXOR					3		/* or not equal */
# define kSpotLogic_NOT						4
# define kSpotLogic_NOR						5
# define kSpotLogic_NAND					6
# define kSpotLogic_XNOR					7		/* or equal */
/* a bit denoting the next ones apply to _only_ this and the next spot */
# define kSpotLogic_next					8

# define kSpotFilter_none					0
# define kSpotFilter_BOR					1
# define kSpotFilter_BAND					2
# define kSpotFilter_BEXOR					3		/* or not equal */
# define kSpotFilter_BNOT					4
# define kSpotFilter_BNOR					5
# define kSpotFilter_BNAND					6
# define kSpotFilter_BXNOR					7		/* or equal */

# define kSpotFilter_LittleEndian			0x80	/* bit */

/* size only applies in the case of a filter or special function */
# define kSpotFilter_SizeMask				0x70	/* in bytes, plus one (eg.: zero is one) */
# define kSpotFilter_SizeShift				4

# define SpotFilter(f,z,e)					(f | (-1+z<<kSpotFilter_SizeShift) | e*kSpotFilter_LittleEndian)

# define kSpotFunc_Equal					0
# define kSpotFunc_LessThan					1
# define kSpotFunc_GreaterThan				2
# define kSpotFunc_OneOf					3		/* in a list of values */
# define kSpotFunc_NotEqual					4
# define kSpotFunc_GreaterOrEqual			5
# define kSpotFunc_LessOrEqual				6
# define kSpotFunc_NotOneOf					7		/* not in a list of values */

/* some of these are ignored in identifying the format,
	but are still used in handling the data */
# define kSpotFunc_AbsoluteOffset			64		/* (must be positive and less than EOF) */
# define kSpotFunc_NearOffset				65		/* (around current position - must point within the file) */

# define kSpotFunc_Signed					0x80	/* bit */

/* cant use TARGET_CPU_68K because some of the inline code requires 680x0
	env68k is for 680x0 - not 68000 - only */
# if env68k
#  pragma parameter set_bh(__A0,__D0,_D1)
   extern void set_bh(void*,short_int,char) =
    {0x5340, 0x6C02, 0x6006, 0x10C1, 0x51C8, -4};

#  pragma parameter __D0 spot_size(__D0)
   extern int spot_size(UInt32) = {0xE9C0, 0x243, 0x5280};
#  pragma parameter __D0 spot_filter(__D0)
   extern int spot_filter(UInt32) = {0xE9C0, 0x304};
#  pragma parameter __D0 spot_func(__D0)
   extern int spot_func(UInt32) = {0xE9C0, 0x447};
#  define spot_length(x)				(byte)x
# else
#  if !defined(rez) && !defined(derez)
#   define set_bh(d,x,b)				do{ byte *_d=d, _b=b; short_int _x=x; if(_x>0) do *_d++=_b; while(_x--);}while(0)
#  endif

#  define spot_size(x)					((((x)>>20) & 3)+1)
#  define spot_filter(x)				(((x)>>16) & 15)
#  define spot_length(x)				((x) & 255)
#  define spot_func(x)					(((x)>>8) & 127)
# endif

#endif /* defined(__FORMAT_RECOGNITION_H) */
