/*
 interface.h
  source code include for AudioWarp interface
*/

#define AppCreatorType			'aud'

#define dockWindowID			128
#define documentWindowID		129

/* window identifiers */
#define kDockWindow				'dock'
#define kDocumentWindow			'doc'
#define kPaletteWindow			'pal'

/* menu ids */
#define MBAppleID				500
#define MBFileID				501
#define MBEditID				502

/* strings */

#define strERRORS				128

#if !defined(rez) && !defined(derez)
enum
{
/* strERRORS */
	outOfMemory			= 0,
	unexpectedError,
	systemTooOldError,
	oldProcessorError,
	oldSystemVersionError,
	insufficientMemoryAtLaunch,
	memoryRunningLow,				/* DANGER Will Robbing-some! */
	failedRequestedAllocation,		/* usually due to limited disk space (look at the error code) */
	couldNotCreateNewDoc,
	fileSystemError
};

/* globals */

extern StandardFileReply	selectedFile;

/* prototypes */

void global_idle_proc(void);

void wait(SInt32 delay_ticks); /* pass negative to update the program event handler */

WindowRef GetWindow(long refCon);

void SetOverheadBoxText(const char *text);
void SetCurrentSoundName(ConstStr255Param text);

void handle_error(short err);

#else
#	include <TemplateType.r>
#endif
