/*
 mixbit_ssnd.h
  source code include for "mixbit" sampled sound encoding

  Version 0.0.0.9

  Created: May 6, 2006
  Revised: June 1, 2006
*/

/*
  sampling formats
    if bit #7 is one, then the compressed data length (U24+1) follows
    if bit #6 is one, then the sound is at double scale (some sounds compress better)

    totalling a maximum of 64 fixed types and 64 variable
*/

/* fixed */

/* NOTE: the U8 PCM format is at a scale of 7, encoding may introduce clipping */
#define _mixbit_format_U8_PCM       0x00
#define _mixbit_format_S16_PCM      0x01
#define _mixbit_format_1_U7_DPCM    0x02 /* 8 bit */
#define _mixbit_format_IMA_ADPCM    0x03 /* 4 bit */

/* variable */

#define _mixbit_format_standard     0x80 /* 8/16 bit */
#define _mixbit_format_mxb_op8      0x81 /* unimplemented */
#define _mixbit_format_KMT_XADPCM   0x82 /* 2.5-6 bit */

/*
   The standard format is lossless at 15 bits:
     <0 ? U15-0xC000 sample : U7-64 delta

   The 1_U7_DPCM format is:
     0xxxxxxx: +t[U7]
     10000000: ^-0x8000
     1xxxxxxx: -t[U7]
       The t table is in "mixbit_ssnd.c".
*/
