/* A.P.: copied from my Marathon source 21-12-2004 7:38 */

#ifndef __MARATHON_MY32BQD_H__
#define __MARATHON_MY32BQD_H__

#ifndef __QDOFFSCREEN__
#include <QDOffscreen.h>
#endif
#ifndef __PALETTES__
#include <Palettes.h>
#endif

#include "screen.h"

void myLockPixels(GWorldPtr);
void myUnlockPixels(GWorldPtr);

PixMapHandle myGetGWorldPixMap(GWorldPtr);
void *myGetPixBaseAddr(GWorldPtr);

OSErr myUpdateGWorld(GWorldPtr*, short depth, const Rect*, CTabHandle, GDHandle, int kind);

void myHideMenuBar(GDHandle, boolean update);
void myShowMenuBar(void);

/* ----- drawing */

typedef enum
{
	_general_overlay,
	_general_text,
	_general_subtraction,
	_adding_overflow,
	_subtracting_overflow,
	NUMBER_OF_ALHA_CHANNEL_STYLES
} _alpha_channel_style;

enum
{
/* color type flags (high bits) */
	_ct_aplha_is_opacity = (long)0x80000000,		/* the QuickDraw OpColor is set to the alpha channel (if available) */

/* color types */
	_ct_general = 0,
	_ct_single,			/* floating-point 32 bit single format (gray, no alpha channel) */
	_ct_AL32,			/* alpha:16, lightness:16 */
	_ct_LA32,			/* lightness:16, alpha:16 */

	/* 2 bits alpha, 10 bits for red, green, and blue */
	_ct_ARGB30,
	_ct_BGRA30,

	/* 2 bits alpha, 10 bits for cyan, yellow, magenta */
	_ct_ACYM30,
	_ct_MYCA30,

	/* black, cyan, yellow, magenta; 8 bits each */
	_ct_KCYM24,
	_ct_KMYC24,
	_ct_CYMK24,
	_ct_MYCK24,

	/* 2 bits alpha, 10 bits for lightness, hue, saturation */
	_ct_ALHS30,
	_ct_SHLA30,

	/* 2 bits alpha, 10 bits for value, hue, saturation */
	_ct_AVHS30,
	_ct_SHVA30,

	/* red, green, blue; 8 bits each */
	_ct_ARGB24 = 16,
	_ct_ABGR24,
	_ct_RGBA24,
	_ct_BGRA24,

	/* red, green, blue; 5 bits each */
	_ct_ARGB15,
	_ct_ABGR15,
	_ct_RGBA15,
	_ct_BGRA15,

	/* red, green, blue; 4 bits each */
	_ct_ARGB12,
	_ct_ABGR12,
	_ct_RGBA12,
	_ct_BGRA12,

	/* full or off */
	_ct_ARGB4,
	_ct_ABGR4,
	_ct_RGBA4,
	_ct_BGRA4,

	/* opred:5, opgreen:6, opblue:5, red:5, green:6, blue:5 */
	_ct_BGRBGR32,

/* general colors (these are not necessarily full colors) */
	_gc_white = 0,
	_gc_light,			/* 93.3% */
	_gc_light_gray,		/* 75% */
	_gc_mid_gray,		/* 50% */
	_gc_dark_gray,		/* 33.3% */
	_gc_dark,			/* 13.3% */
	_gc_near_black,		/* 6.67% */
	_gc_black,

	_gc_red,
	_gc_orange,
	_gc_yellow,
	_gc_green,
	_gc_cyan,
	_gc_blue,
	_gc_violet,
	_gc_magenta,

	_gc_dark_red,
	_gc_dark_green,
	_gc_dark_blue,
	_gc_dark_cyan,
	_gc_dark_yellow,
	_gc_dark_magenta,

	_gc_light_gray_blue,
	_gc_gray_blue,
	_gc_dark_gray_blue,
	_gc_navy_blue,

	_gc_turquoise,
	_gc_tan,
	_gc_brown,
	_gc_sky_blue,
	_gc_sea_blue,
	_gc_lavender
};

void SetRawForeColor(UInt32 rawColor, int colorType);
void SetRawBackColor(UInt32 rawColor, int colorType);
void SetRawOpacity(UInt32 rawColor, int colorType);

void ARGB32ForeColor(ARGB32 _color, _alpha_channel_style style);
void RGB32BackColor(ARGB32 _color);

/* custom offscreen stuff */

enum
{
	kXPortPixels16ByteAligned	= 0x40,
	kXPortPixelsLocked			= 0x80
};

typedef struct XGrafPort
{
	CGrafPort		port;
	Handle			pixelData;
	GDHandle		device;
} *XGrafPtr;

#define CalculateRowBytes(w,s,t,m)		((((w)*(s)+(t))>>3)&(m))

CTabHandle GenerateGrayCTab(SInt32 pixelSize);

GDHandle NewOffscreenGDevice(
	SInt16 pixelSize,
	SInt16 version,
	SInt16 rowBytes,
	UInt16 cmpSpec,
	CTabHandle ct,			/* can be NULL */
	const Rect *bounds,
	void *pixelData);

OSErr OpenOffscreenCPort(
	XGrafPtr port,
	CTabHandle ct,			/* can be NULL */
	const Rect *bounds,
	SInt32 depth,
	SInt32 flags);

void DisposeOffscreenCPort(XGrafPtr port);

#endif
