
#include "macintosh_cseries.h"

#ifndef __DIALOGS__
# include <Dialogs.h>
#endif
#ifndef __LISTS__
# include <Lists.h>
#endif
#ifndef __CONTROLDEFINITIONS__
# include <ControlDefinitions.h>
#endif

#include "interface.h"
#include "shell.h"
#include "myDialogs.h"

/* code */

void LSelectAll(Boolean setThem, ListHandle list)
{
	Cell			cell;

	RgnHandle		trgn;
	ListPtr			lp;
	SInt16			hcount, vcount;
	SInt8			old_flags;

	if (list==(ListHandle)NULL || (lp=*list)==NULL)
		return;
	hcount = RECT_WIDTH(&lp->dataBounds),
		vcount = RECT_HEIGHT(&lp->dataBounds),
		old_flags = lp->listFlags;
	lp->listFlags |= lDrawingModeOff;

	while(--hcount>=0)
		while(vcount>0)
		{
			cell.h = hcount, cell.v = --vcount;
			LSetSelect(setThem,cell,list);
		}

	(**list).listFlags = old_flags;
	if (!(old_flags & lDrawingModeOff))
		if ((trgn=NewRgn())!=(RgnHandle)NULL)
		{
			(**trgn).rgnBBox = (**list).rView;
			LUpdate(trgn,list);
			DisposeRgn(trgn);
		}
}

ListHandle		current_list = (ListHandle)NULL;

enum
{
	iLIST_BOX = 3,
	iHEADER_STR,
	/*iLIST_SCROLL*/
	iSAVE_LIST
};

static pascal void VertListControl(ControlRef theControl, short partCode)
{
	ControlRef		hScroll;
	SInt16			hvalue = 0;

	if ((hScroll=(**current_list).hScroll)!=(ControlRef)NULL)
		hvalue = (**hScroll).contrlValue;
	switch(partCode)
	{
	case kControlUpButtonPart:
		LScroll(hvalue,-1,current_list);
		break;
	case kControlDownButtonPart:
		LScroll(hvalue,1,current_list);
		break;
	case kControlPageUpPart:
		LScroll(hvalue,1-RECT_HEIGHT(&(**current_list).visible),current_list);
		break;
	case kControlPageDownPart:
		LScroll(hvalue,RECT_HEIGHT(&(**current_list).visible)-1,current_list);
	}
}

static pascal Boolean ListDialogFilter(DialogRef dlg,
	EventRecord *event,
	DialogItemIndex *itemHit)
{
	Point			evloc = event->where;
	Rect			ir;
	Cell			selected_cell;

	Handle			ih;
	GrafPtr			old_port;
	ControlRef		ctl;
	SInt16			h = 0, v = 0;
	short			it, cell_count, hit;
	boolean			update, handled = FALSE;

	GetPort(&old_port);
	cell_count = RECT_HEIGHT(&(**current_list).dataBounds);		
	*(SInt32*)&selected_cell = 0;
	if ((update=HandleEvent(dlg,event,true,true))==-1)
		goto cancel;
	SetPortDialogPort(dlg);
	switch(event->what)
	{
	case mouseUp:
		/*GlobalToLocal(&evloc);
		*itemHit = FindDialogItem(dlg,evloc);
		handled = TRUE;*/
		break;
	case mouseDown:
		GlobalToLocal(&evloc);
		GetDialogItem(dlg,iLIST_BOX,&it,&ih,&ir);
		if (PtInRect(evloc,&ir))
		{
			if (LClick(evloc,event->modifiers,current_list))
				goto okay;
			handled = TRUE;
			break;
		}
		switch(hit=FindControl(evloc,dlg,&ctl))
		{
		case kControlUpButtonPart:
		case kControlDownButtonPart:
		case kControlPageUpPart:
		case kControlPageDownPart:
			if (ctl==(**current_list).vScroll)
				TrackControl(ctl,evloc,VertListControl);
			else
				dprintf("What the-?!");
			break;
		case kControlIndicatorPart:
			if (ctl=(**current_list).hScroll)
				h = (**ctl).contrlValue;
			if (ctl=(**current_list).vScroll)
				v = (**ctl).contrlValue;
			TrackControl(ctl,evloc,NULL);
			if (ctl=(**current_list).hScroll)
				h = (**ctl).contrlValue-h;
			if (ctl=(**current_list).vScroll)
				v = (**ctl).contrlValue-v;
			LScroll(h,v,current_list);
		}
		break;
	case keyDown:
	case autoKey:
		if (event->modifiers & cmdKey)
		{
			switch(event->message & charCodeMask)
			{
			case 'a':
			case 'A':
				LSelectAll(true,current_list);
			}
			break;
		}
		switch(event->message & charCodeMask)
		{
		case kEnterCharCode:
		case kReturnCharCode:
		okay:
			handled = TRUE, *itemHit = 1;
			GetDialogItem(dlg,1,&it,&ih,&ir);
			goto animCtl;
		case kEscapeCharCode:
		case '.':
		cancel:
			handled = TRUE, *itemHit = 2;
			GetDialogItem(dlg,2,&it,&ih,&ir);
		animCtl:
			animate_dialog_button(dlg,*itemHit);
			goto end;
		case kUpArrowCharCode:
			if (LGetSelect(true,&selected_cell,current_list)
					&& !(event->modifiers & cmdKey))
			{
				if (selected_cell.v>0)
				{
					LSetSelect(false,selected_cell,current_list);
					--selected_cell.v;
					LSetSelect(true,selected_cell,current_list);
					LAutoScroll(current_list);
				}
			} else
			{
				*(SInt32*)&selected_cell = 0;
				LSetSelect(true,selected_cell,current_list);
				LAutoScroll(current_list);
			}
			*itemHit = iLIST_BOX;
			handled = TRUE;
			break;
		case kDownArrowCharCode:
			if (LGetSelect(true,&selected_cell,current_list)
					&& !(event->modifiers & cmdKey))
			{
				if (selected_cell.v<cell_count-1)
				{
					LSetSelect(false,selected_cell,current_list);
					++selected_cell.v;
					LSetSelect(true,selected_cell,current_list);
					LAutoScroll(current_list);
				}
			} else
			{
				selected_cell.v = cell_count-1;
				LSetSelect(true,selected_cell,current_list);
				LAutoScroll(current_list);
			}
			*itemHit = iLIST_BOX;
			handled = TRUE;
			break;
		case kHomeCharCode:
			LScroll(SHORT_MIN,SHORT_MIN,current_list);
			break;
		case kEndCharCode:
			LScroll(SHORT_MAX,SHORT_MAX,current_list);
			break;
		case kPageUpCharCode:
			LScroll(0,1-RECT_HEIGHT(&(**current_list).visible),current_list);
			break;
		case kPageDownCharCode:
			LScroll(0,RECT_HEIGHT(&(**current_list).visible)-1,current_list);
		default:
			goto fallOut;
		};
		break;
	case updateEvt:
		if (update)
		{
			BeginUpdate(dlg);
			DrawDialog(dlg);
			LUpdate(GetDialogPort(dlg)->visRgn,current_list);
			GetDialogItem(dlg,iLIST_BOX,&it,&ih,&ir);
			PenSize(1,1);
			FrameRect(&ir);
			GetDialogItem(dlg,1,&it,&ih,&ir);
			if ((it & 0x7F)==kButtonDialogItem)
			{
				InsetRect(&ir,-4,-4);
				PenSize(3,3);
				FrameRoundRect(&ir,16,16);
				PenSize(1,1);
			}
			EndUpdate(dlg);
		}
	default:
	fallOut:
		if (!handled && IsDialogEvent(event))
			handled = DialogSelect(event,&dlg,itemHit);
	}
end:
	SetPort(old_port);
	return handled;
}

static SInt32 new_list_from_text(const char *data, Point csize, const Rect *box,
	WindowRef window, char itemd, char lined);
static SInt32 new_list_from_data(const void *data, Point csize, const Rect *box,
	WindowRef window, struct data_array_spec *spec);

UInt32 ListDialog(cs_fontspec *font_spec, UInt8 *prompt, const void *data,
	UInt16 type, UInt16 flags, list_spec_data *spec_data,
	SInt16 *aitems, SInt16 *bitems)
{
	FontInfo		finfo;
	Rect			box;
	Cell			cell;
	Point			csize;

	Handle			ih;
	DialogRef		dlg = NULL;
	GrafPtr			old_port;
	Ptr				dstore = NULL;
	SInt32			line_count, counts = 0;
	short			familyID, it, x;

	GetPort(&old_port);
	if (data==NULL)
	{
		assert(0);
		goto end;
	}
	if ((dstore=NewPtr(sizeof(DialogRecord)))==(Ptr)NULL)
	{
		assert(0);
		goto end;
	}
	if ((dlg=GetNewDialog(LIST_DLOG_ID,dstore,kFirstWindowOfClass))==(DialogRef)NULL)
	{
		dprintf("couldnt get dialog ID %d", LIST_DLOG_ID);
		goto end;
	}
	SetPortDialogPort(dlg);

	if (!(flags & showSaveListButton))
		HideDialogItem(dlg,iSAVE_LIST);

	if (prompt)
	{
		GetDialogItem(dlg,iHEADER_STR,&it,&ih,&box);
		SetDialogItemText(ih,prompt);
	}
	GetDialogItem(dlg,iLIST_BOX,&it,&ih,&box);
	InsetRect(&box,1,1);

	if (font_spec==NULL)
	{
		TextFont(0);
		TextSize(12);
		TextFace(0);
	} else
		set_port_font(font_spec);

	GetFontInfo(&finfo);
	csize.h = RECT_WIDTH(&box), csize.v = finfo.ascent+finfo.descent+1;
	switch(type)
	{
	case delimitedTextType:
		line_count = new_list_from_text(data,csize,&box,dlg,
			spec_data->dtext.item_delimiter,spec_data->dtext.line_delimiter);
		break;
	case dataArrayType:
		line_count = new_list_from_data(data,csize,&box,dlg,&spec_data->adata);
	}
	if (line_count<0)
		goto end;

	LSetDrawingMode(1,current_list);
	(**current_list).selFlags = flags;
	ShowWindow(GetDialogWindow(dlg));

	do{ModalDialog(ListDialogFilter,&it);} while(it!=1 && it!=2);

	if (it!=1)
		goto end;
	for(x=0,*(SInt32*)&cell=0; x<line_count; ++x,++cell.v)
	{
		if (LGetSelect(true,&cell,current_list))
		{
			if (cell.h)
			{
				//if (bitems) *bitems++ = cell.v, ++counts;
				/* ball- */
				dprintf("-sack.");
			} else if (aitems)
				*aitems++ = cell.v, counts += 0x10000;
		} else
			break;
	}
	for(x=0; x<line_count; ++x)
	{
		cell.v = x, cell.h = 1;
		if (LGetSelect(true,&cell,current_list))
		{
			if (cell.h)
			{
				if (bitems)
					*bitems++ = cell.v, ++counts;
			} /*else
				dprintf("Got to get off the weed, man.");*/
		} else
			break;
	}
end:
	if (current_list)
	{
		LDispose(current_list);
		current_list = (ListHandle)NULL;
	}
	SetPort(old_port);
	if (dlg!=NULL)
		DisposeDialog(dlg);
	else if (dstore)
		DisposePtr(dstore);
	return counts;
}

static const char	list_failure[] = "couldnt create list... AH!!!!!";

static SInt32 new_list_from_text(const char *data,
	Point csize, const Rect *box, WindowRef window,
	char item_delim, char line_delim)
{
	Rect			bounds;
	Cell			cell;
	const char		*loffset, *text = data;
	SInt32			length;
	short			x;

	length = strlen(text);
	*(SInt32*)&bounds = 0, bounds.right = item_delim ? 2 : 1,
	bounds.bottom = memcnt(text,line_delim,length)+(*text!=0);
	if ((current_list=LNew(box,&bounds,csize,0,window,false,false,false,true))==(ListHandle)NULL)
	{
		vassert(0,list_failure);
		return -1;
	}
	/* build the list from the C string */
	for(x=0; (loffset=strchr(text,line_delim))!=NULL; ++x)
	{
		register const char		*ioffset;

		if (item_delim && (ioffset=memchr(text,item_delim,(long)loffset-(long)text)))
		{
			cell.h = 1, cell.v = x;
			LSetCell(ioffset+1,(long)loffset-(long)ioffset-1,cell,current_list);
		} else
			ioffset = text;
		cell.h = 0, cell.v = x;
		LSetCell(text,(long)loffset-(long)ioffset,cell,current_list);
		text = loffset+1;
	}
	if (length)
	{
		register const char		*ioffset;

		loffset = data+length;
		if (item_delim && (ioffset=memchr(text,item_delim,(long)loffset-(long)text)))
		{
			cell.h = 1, cell.v = x;
			LSetCell(ioffset+1,(long)loffset-(long)ioffset-1,cell,current_list);
		} else
			ioffset = text;
		cell.h = 0, cell.v = x;
		LSetCell(text,(long)loffset-(long)ioffset,cell,current_list);
	}

	return bounds.bottom;
}

static SInt32 new_list_from_data(const void *data,
	Point csize, const Rect *box, WindowRef window,
	struct data_array_spec *spec)
{
	Rect			bounds;
	Cell			cell;
	UInt32			*list = (UInt32*)spec;
	SInt32			length;
	short			x;

	*(SInt32*)&bounds = 0, bounds.right = 1, bounds.bottom = *list++;
	if ((current_list=LNew(box,&bounds,csize,0,window,false,false,false,true))==(ListHandle)NULL)
	{
		vassert(0,list_failure);
		return -1;
	}
	list = *(UInt32**)list;
	/* build the list from the C string */
	for(x=0; x<bounds.bottom; ++x)
	{
#if 0
		cell.h = 0, cell.v = x, length = vsprintf(temporary,(const char*)list,data);
		if (_formatParam) data = _formatParam;	/* continue after the last arg. */
#endif
		dsprintf(temporary,(const char*)list,data);
		LSetCell(temporary,length,cell,current_list);
	}

	return bounds.bottom;
}
