/*
  myDialogs.h
   source code include for AudioWarp dialogs and misc. dialog routines

  Copyright (C) 2005-2006 by Adam Pickett

  This material has not yet to be authorized for use in the public domain.
  Written consent by the author(s) must be granted before public disclosure.
  Copying without permission is prohibited.
*/

/* constants */

#define LIST_DLOG_ID			133

#if !defined(rez) && !defined(derez)

#include <cs_text.h>

/* structures */

struct delimited_text_spec
{
	char			item_delimiter, line_delimiter;
};

struct data_array_spec
{
	SInt32			count;

   /* printf form, except data types requiring a pointer use the literal data
     in the focused source data instead */
	char			*form;
};

typedef union list_spec_data
{
	struct delimited_text_spec	dtext;
	struct data_array_spec		adata;
} list_spec_data;

/* returns the count; font_spec can be NULL */
enum
{
/* data type (low 16 bits) */
	delimitedTextType,
	dataArrayType,

/* SelectTextLineDlg flags */
	showSaveListButton		= 0x8000

/* low byte of flags go directly to the list itself */
};

/* prototypes */

void LSelectAll(Boolean setThem, ListHandle list);

UInt32 ListDialog(cs_fontspec *font_spec, UInt8 *prompt, const void *data,
	UInt16 type, UInt16 flags, list_spec_data *spec_data,
	SInt16 *aitems, SInt16 *bitems);

#endif /* !defined(rez) && !defined(derez) */
