
#include <AIFF.h>

/* constants */

/* program flags */

#define SLOT_DIRTY					0x80

enum
{	/* flags */
	_reverse_playback_is_intended	= 0x1,
	_uses_64_bit_file_positioning	= 0x4000
};

typedef struct edit_record/*(12) */
{
	SInt16			category, reference;
	UInt32			start, length;
} edit_record, **edit_record_handle;

typedef struct marker_record/*(272) */
{
	UInt64			location;
	LongDateTime	time_stamp;
	Str31			name;
	Str63			comment;
} marker_record, **marker_record_handle;

/* structures */

typedef struct sfmt_header/*(24) */
{
	OSType			format_on_disk;

	UInt8			channel_count, channel_size;	/* channel_size is in bits */
	UInt16			sample_size;	/* total size (channel_count*channel_size+extra) */
	UInt64			sample_count;	/* high 32 bits always zero on pre HFS+ */
	UFixed32		sample_rate;
} sfmt_header;

typedef struct info_header/*(512) -- will expand */
{
	Str63			title, author, copyright;
	SInt16			description_length;
	UInt8			description[302];
	UInt64			loop_start, loop_length;
} info_header;

typedef struct documentRec/*(616/808) */
{
	FSSpec			file_owner;
	UInt16			flags;
	OSType			file_type;
	WindowRef		window;

	sfmt_header		edit_format;
	info_header		general_info;

	/* file_ref is the current file being edited and cache_ref is the virtual image */
	/*	on disk (only used when >8MB or the application heap cant hold it all) */
	SInt16			file_ref, cache_ref;

	Handle			active_chunk;		/* the sound that is currently developed... */
	UInt64			chunk_start;		/* must be zero if not cached */
	UInt32			chunk_length;

	edit_record_handle		edits;
	marker_record_handle	markers;
} documentRec;

typedef struct
{
	int				count, front;
	documentRec		index[
#ifdef MAXIMUM_OPEN_DOCUMENTS_COUNT
		MAXIMUM_OPEN_DOCUMENTS_COUNT
#elif !__option(thinkc) && !__option(objectc)
		1
#endif
		];
} documentListRec;

/* globals */

extern documentListRec			openDocuments;

/* prototypes */

boolean noMoreDocs(void);

documentRec *NewDoc(documentRec*, boolean new_window);
boolean OpenDoc(boolean get);
boolean CloseDoc(int which);
boolean WCloseDoc(WindowRef);
boolean askSave(int which);
boolean SaveDoc(int which, boolean dialog);

int WFindDoc(WindowRef);
int RFindDoc(SInt16);			/* refNum of the file */

void UpdateDocWindow(int which);
