/*
 playback.c

All dates in international format (DD-MM-YYYY)

A.P.:
2006
	May 15
		Created.
*/

#include <cs_system.h>

#include <string.h>

#include "interface.h"

#include "mySound.h"

/* constants */

static const char	sdig[] = "SndDoImmediate(%p,%p,false) gave #%d";
static const char	sdcg[] = "SndDoCommand(%p,%p,false) gave #%d";

/* globals */

volatile boolean	mySound_stop = FALSE;
volatile short		mySound_counter;

/* private prototypes */

static pascal void my_callback(SndChannelPtr chan, SndCommand *cmd);

/* code */

boolean try_snd(ExtSoundHeader *h, ufixed multiplier, boolean loop)
{
	EventRecord		myEvent;
	SndCommand		command;

	SndChannelPtr	channel;
	OSErr			err = 0;
	boolean			dump_flag = FALSE;

	if ((channel=(SndChannelPtr)new_platform_ptr(sizeof(SndChannel)))==(SndChannelPtr)NULL)
	{
		SetOverheadBoxText("could not allocate pointer for sound channel");
//		handle_error(MemError());
		return;
	}
	memset(channel,0,sizeof(SndChannel));

	channel->qLength = stdQLength;
	if ((err=SndNewChannel(&channel,sampledSynth,
			h->numChannels>1 ? initStereo : initMono,my_callback))!=noErr)
		{dprintf("SndNewChannel(%p) gave #%d", &channel,err); goto end;}

	if (multiplier!=0x10000)
	{
		*(SInt32*)&command.cmd = rateMultiplierCmd<<16,
			command.param2 = multiplier;
		if ((err=SndDoImmediate(channel,&command))!=noErr)
		{
			dprintf(sdig, channel,&command,err);
			goto bail;
		}
	}
	SetCurrentSoundName(selectedFile.sfFile.name);
	wait(-2);
	do
	{
		int			j = -1;

		*(SInt32*)&command.cmd = bufferCmd<<16,
			command.param2 = (SInt32)h;
		if ((err=SndDoCommand(channel,&command,false))!=noErr)
		{
			dprintf(sdcg, channel,&command,err);
			goto bail;
		}
		mySound_counter = 0;
		*(SInt32*)&command.cmd = callBackCmd<<16,
			command.param2 = 0;
		if ((err=SndDoCommand(channel,&command,false))!=noErr)
		{
			dprintf(sdig, channel,&command,err);
			goto bail;
		}

		while(mySound_counter==0)
		{
			UInt8		mouse;

			if ((mouse=Button())!=0 || GetNextEvent(keyDownMask | autoKeyMask,&myEvent)
					&& ((char)myEvent.message=='d' || (char)myEvent.message=='.')
					|| mySound_stop)
			{
				dump_flag = (char)myEvent.message=='d';
				*(SInt32*)&command.cmd = quietCmd<<16,
					command.param2 = (SInt32)h;
				if ((err=SndDoCommand(channel,&command,false))!=noErr)
					dprintf(sdcg, channel,&command,err);
				goto bail;
			}
		}
	} while(loop && !Button() && !mySound_stop);
bail:
	if ((err=SndDisposeChannel(channel,true))!=noErr)
		dprintf("SndDisposeChannel(%p,true) gave #%d", channel,err);
end:
	if (channel!=(SndChannelPtr)NULL)
		dispose_platform_ptr((Ptr)channel); /* should handle NULL */

	mySound_stop = FALSE;

	return dump_flag;
}

static pascal void my_callback(SndChannelPtr chan, SndCommand *cmd)
{
	++mySound_counter;
}
