/*

praxGlue.cpp
	5-10-2004
*/

#include <praxInfinite.h>

template <class praxSingle> class prax;
null_template class prax<praxSingle>;

template <class praxSingle> class prax
{
private:
	T	value_;

public:
	//DEC_OBJ_LOCK(c_mutex)
	typedef T value_type;

	prax (const T& value = T()) : value_ (value) {}

	~prax () { }

	T value () const  { return value_; }

	prax <T>& operator= (const T& rhs)
	{
		value_.exp = 0, value_.sig = rhs;
		value_ = rhs;
		return *this;
	}

	prax <T>& operator+= (const T& rhs)
	{
		T	temp;

		temp.exp = 0, temp.sig = rhs;
		F4b4Add(value_,value_,temp);
		return *this;
	}

	prax <>& operator-= (const T& rhs)
	{
		T	temp;

		temp.exp = 0, temp.sig = rhs;
		F4b4Sub(value_,value_,temp);
		return *this;
	}

	prax <>& operator*= (const T& rhs)
	{
		T	temp;

		temp.exp = 0, temp.sig = rhs;
		F4b4Mul(value_,value_,temp);
	}

	prax <>& operator/= (const T& rhs)
	{
		T	temp;

		temp.exp = 0, temp.sig = rhs;
		F4b4Div(value_,value_,temp);
	}

#ifdef MSIPL_MEMBER_TEMPLATE
	template <class X> prax (const prax<X>& cx) 
                    : re_ (cx.real ()), im_ (cx.imag ()) {}

	//
	// Member operator functions
	//
    
	template <class X>
	prax<T>&
	operator= (const prax<X>& cx)
	{
		if (this != &cx) value_ = cx.value ();
		return *this;
	}

	template <class X> prax<T>& operator+= (const prax<X>& cx)
	{
		value_ += cx.value ();
		return *this;
	}
   
	template <class X> prax<T>& operator-= (const prax<X>& cx)
	{
		value_ -= cx.value ();
		return *this;
	}

	template <class X> prax<T>& operator*= (const prax<X>& cx)
	{
		value_ *= cx.value ();
		return *this;
	}

	template <class X> prax<T>& operator/= (const prax<X>& cx)
	{
		value_ /= cx.value ();
		return *this;
	}

#else

	prax (const prax<T>& cx)
                     : re_ (cx.real ()), im_ (cx.imag ()) {}

	//
	// Member operator functions
	//
	prax<T>& operator= (const prax<T>& cx)
	{
		WRITE_LOCK(c_mutex);
		if (this != &cx) value_ = cx.value ();
		return *this;
	}

	prax<T>& operator+= (const prax<T>& cx)
	{
		value_ += cx.value ();
		return *this;
	}

	prax<T>&
	operator-= (const prax<T>& cx)
	{
		value_ -= cx.value ();
		return *this;
	}

	prax<T>& operator*= (const prax<T>& cx)
	{
		value_ *= cx.value ();
		return *this;
	}

	prax<T>& operator/= (const prax<T>& cx)
	{
		value_ /= cx.value ();
		return *this;
	}

#endif

};

null_template
class prax<praxSingle> {

private :
	praxSingle	value_;

public :
	DEC_OBJ_LOCK(c_mutex)
	typedef praxSingle   value_type;

	prax (praxSingle value = 0) 
	: value_ (value) {}

	prax (const prax<praxSingle>& cx) 
	: value_ (cx.value ()) {}

	explicit prax (const prax<praxSingle>& cx);
 
	~prax () { }

	praxSingle value () const { READ_LOCK(c_mutex); return value_; }

	prax <praxSingle>& operator= (praxSingle rhs)
	{
		WRITE_LOCK (c_mutex);
		re_ = rhs;
		im_ = 0.0f;	// hh 971221
		return *this;
	}

	prax <praxSingle>& operator+= (praxSingle rhs)
	{
		WRITE_LOCK (c_mutex);
		value_ += rhs;
		return *this;
	}

	prax <praxSingle>& operator-= (praxSingle rhs)
	{
		value_ -= rhs;
		return *this;
	}

	prax <praxSingle>& operator*= (praxSingle rhs)
	{
		value_ *= rhs;
		return *this;
	}

	prax <praxSingle>& operator/= (praxSingle rhs)
	{
		value_ /= rhs;
		return *this;
	}

#ifdef MSIPL_MEMBER_TEMPLATE
	template <class X> 
	prax<praxSingle>& operator= (const prax<X>& cx);

	template <class X>
	prax<praxSingle>& operator+= (const prax<X>& cx);

	template <class X>
	prax<praxSingle>& operator-= (const prax<X>& cx);

	template <class X>
	prax<praxSingle>& operator*= (const prax<X>& cx);

	template <class X>
	prax<praxSingle>& operator/= (const prax<X>& cx);

#else
	prax<praxSingle>& operator= (const prax<praxSingle>& cx);
	prax<praxSingle>& operator+= (const prax<praxSingle>& cx);
	prax<praxSingle>& operator-= (const prax<praxSingle>& cx);
	prax<praxSingle>& operator*= (const prax<praxSingle>& cx);
	prax<praxSingle>& operator/= (const prax<praxSingle>& cx);
#endif
};

/***/

template <class T> 
inline 
prax<T> abs (const prax<T>& cx)
{
	cx.value.exp &= 0x7FFFFFFF;
	return prax<T> ( r );				
}

template <class T> 
inline 
prax<T> sqrt (const prax<T>& cx)
{
	praxSingle	r;

	F4b4Sqrt(&r,&cx);
	return prax<T> ( r );				
}

//bs add

template <class T> 
inline 
prax<T> operator+ (const prax<T>& cx)
{
	return prax<T> (cx.value ());
}

template <class T>
inline 
prax<T> operator+ (const prax<T>& c1, const prax<T>& c2)
{
	praxSingle	r;

	F4b4Add(&r,&c1.value(),&c2.value());
	return prax<T> (r);
}

//bs sub

template <class T> 
inline 
prax<T> operator- (const prax<T>& cx)
{
	return prax<T> (cx.value ());
}

template <class T>
inline 
prax<T> operator- (const prax<T>& c1, const prax<T>& c2)
{
	praxSingle	r;

	F4b4Sub(&r,&c1.value(),&c2.value());
	return prax<T> (r);
}

//bs mul

template <class T> 
inline 
prax<T> operator* (const prax<T>& cx)
{
	return prax<T> (cx.value ());
}

template <class T>
inline 
prax<T> operator* (const prax<T>& c1, const prax<T>& c2)
{
	praxSingle	r;

	F4b4Sub(&r,&c1.value(),&c2.value());
	return prax<T> (r);
}

//bs div

template <class T> 
inline 
prax<T> operator/ (const prax<T>& cx)
{
	return prax<T> (cx.value ());
}

template <class T>
inline 
prax<T> operator/ (const prax<T>& c1, const prax<T>& c2)
{
	praxSingle	r;

	F4b4Sub(&r,&c1.value(),&c2.value());
	return prax<T> (r);
}

//bs cmp

template <class T>
inline bool operator== (const prax<T>& c1, const prax<T>& c2)
{ return (F4b4Cmp(&c1,&c2)==0); }

template <class T>
inline bool operator!= (const prax<T>& c1, const prax<T>& c2)
{ return (F4b4Cmp(&c1,&c2)!=0); }

template <class T>
inline bool operator< (const prax<T>& c1, const prax<T>& c2)
{ return (F4b4Cmp(&c1,&c2)<0); }

template <class T>
inline bool operator> (const prax<T>& c1, const prax<T>& c2)
{ return (F4b4Cmp(&c1,&c2)>0); }

template <class T>
inline bool operator<= (const prax<T>& c1, const prax<T>& c2)
{ return (F4b4Cmp(&c1,&c2)<=0); }

template <class T>
inline bool operator>= (const prax<T>& c1, const prax<T>& c2)
{ return (F4b4Cmp(&c1,&c2)>=0); }
