/*
 screen.c

 a source file for AudioWarp
*/

#include "macintosh_cseries.h"
#include "screen.h"
#include "interface.h"

/* -------- constants */

#define MAIN_WINDOW_HEIGHT		80

/* -------- globals */

WindowRef			dock_window = (WindowRef)NULL;

/* -------- code */

void initialize_screen()
{
	if (dock_window) return;
	dock_window = (WindowRef)NewPtr(sizeof(CWindowRecord));
	assert(dock_window);
	dock_window = GetNewCWindow(dockWindowID,dock_window,kFirstWindowOfClass);
	assert(dock_window);

	update_dock_window_rectangle();
	ShowWindow(dock_window);
}

void update_dock_window_rectangle()
{
	Rect	srect = (**GetMainDevice()).gdRect;

	MoveWindow(dock_window,4,24,1);
	SizeWindow(dock_window,RECT_WIDTH(&srect)-8,MAIN_WINDOW_HEIGHT,0);
}

int get_current_graphics_mode(void)
{
	GDHandle		gd;

	if ((gd=GetMainDevice())==NULL)
		return -1;

	return (**(**gd).gdPMap).pixelSize>2;
}

/* we have no fades, so this will do */
void stop_interface_fade()
{
}
