
#pragma once

#define NUMBER_OF_CLICK_PROFILES		3

/* constants */

typedef enum
{
/* targets */
	kTargetMenubar,
	kTargetWindowTitlebar,
	kTargetWindowClosebox,
	kTargetWindowGrow,
	kTargetWindowZoom,
	kTargetWindowSpace,
	kTargetWindowControl,
	kTargetWindowData
} runtime_target_type;

#define kFrontDocument					-1
#define kAllDocuments					-2

enum
{	/*	show/hide flags */
	kSHSuspendResume		= 0x1,
	kSHResume				= 0x2
};

/* structures */

struct click_profile
{
	UInt32			when;	/* in ticks */
	Point			where;
	short			target_type, target_index;
};

/* globals */

extern struct click_profile		click_profile_list[];

#ifdef mac
extern RgnHandle	gpRgn;
#endif

extern long		QuickTime_version, SoundManager_version, FileSystem_attrs;

/* prototypes */

void showAbout(void);

void Idle(void);

/* event and dialog can be NULL */
boolean HandleEvent(DialogRef dialog, EventRecord *event, boolean halted, boolean external);

void FullSelectWindow(WindowRef window, boolean front);
void ShowHideFloating(WindowRef window);
void ShowHideAllFloating(short flags);
void HandleUpdateWindow(WindowRef window);

void ProgramMenuChoice(long menuHit); /* called whenever a menu is hit in the menubar */
void ProgramMenuInit(void); /* called right before DrawMenuBar at initialization */
void UpdateMenus(void); /* called whenever the menubar needs an update */

void initialize_menubar(void);
MenuRef add_menu_resource(short id, short loc);
void CheckOnly(short m, short f, short l, short i, boolean c);
