
#include "macintosh_cseries.h"

#include "my32bqd.h"

#include <Movies.h>
#include <GXMath.h>

#include "interface.h"
#include "screen.h"
#include "shell.h"		/* strictly for HandleEvent */

#include <stdlib.h>

#define INITIAL_COMPRESSED_MAXIMUM			MEG/4

/*#define POINT_COUNT (sizeof(crap_points)/sizeof(crap_points[0])) */
#define POINT_COUNT							1500
#define rn30()								((rand()<<15)|rand())

extern boolean	gDone;

static OSErr GenerateVideoFrames(Media media,
	GWorldPtr master_port, GWorldPtr port,
	Rect *master_frame, Rect *frame,
	UInt16 count,
	boolean display)
{
	gxPoint		*crap_points = NULL;	/*static gxPoint	crap_points[100] */

	RGBColor	whatever;

	ImageDescriptionHandle	image_description = (ImageDescriptionHandle)NULL;

	GDHandle	oldgd;
	Handle		data_handle;
	GWorldPtr	oldport;
	Ptr			compressed_data;
	UInt64		last_ticks, ticks;
	int			length;
	long		maximum_size;
	UInt32		x = 0, y = 0, setup = 1;
	Fixed		tx = ((RECT_WIDTH(master_frame)+RECT_HEIGHT(master_frame))<<16)/POINT_COUNT;
	Fixed		ty = (tx*3)>>2, tv;
	OSErr		err = 0;

	*(Float64*)&last_ticks = 0, whatever.blue = *(SInt32*)&whatever = 0;
	GetGWorld(&oldport,&oldgd);
	if (!(crap_points=malloc(POINT_COUNT*sizeof(crap_points[0]))))
	{
		dprintf("no memory!");
		goto end;
	}
	crap_points[0].x = crap_points[0].y =
		(RECT_WIDTH(master_frame)<<17)/111+master_frame->left;
	if (!(data_handle=NewHandle(INITIAL_COMPRESSED_MAXIMUM)))
	{
		err = MemError();
		dprintf("error creating initial compressed data handle: %d", err);
		goto end;
	}
	if (!(image_description=(ImageDescriptionHandle)NewHandle(4)))
	{
		err = MemError();
		dprintf("error creating image description handle: %d", err);
		goto data;
	}
	myLockPixels(port);

	/* set up our crap */
	SetGWorld(master_port,NULL);
	PenSize(2,2);
	SetGWorld(oldport,oldgd);

	for(y=1,tv=tx/5; y<POINT_COUNT; ++y)
	{
		crap_points[y].x = crap_points[y-1].x+(((rn30()%tx)-tv)>>1);
		crap_points[y].y = crap_points[y-1].y+(((rn30()%tx)-tv)>>1);
	}
	/*th = master_frame->right/7, tv = master_frame->bottom/7; */
	tv = tx/2-0x13000;
	for(x=0; x<count; ++x)
	{
		if (display)
		{
		/*	SetPort(wDock);
			MoveTo(7,39);
		*/
			if (!setup++)
			{
				short		familyID;
dprintf("AHHHHHHHHHHHHH!!!!!!!!!!!");
				GetFNum("\pArial",&familyID);
				TextMode(srcOr);
				TextFont(familyID);
				TextSize(14);
				TextFace(bold);
				RGBForeColor(system_colors+gray87Percent);
			}
			sprintf(temporary,"Frame Index: %d, Remaining: %d", x,count-x-1);
			SetCrapBoxText(temporary);
		}

		SetGWorld(master_port,NULL);
		SetRawBackColor(0x80999999+x,_ct_ARGB24 | _ct_aplha_is_opacity);
		EraseRect(master_frame);
		whatever.red += (rand()>>1)-16383;
		whatever.green += (rand()>>1)-16383;
		whatever.blue += (rand()>>1)-16383;
		/*SetRawForeColor(0x00336511,_ct_ARGB24);*/
		RGBForeColor(&whatever);
		MoveTo(*(SInt16*)&crap_points[0].x,*(SInt16*)&crap_points[0].y);
		for(y=0; y<POINT_COUNT; ++y)
		{
			crap_points[y].x += (rn30()%tx)-tv;
			crap_points[y].y += (rn30()%ty)-tv;
			LineTo(*(SInt16*)&crap_points[y].x,*(SInt16*)&crap_points[y].y);
		} while(--y);

		RGBForeColor(&rgb_black);
		RGBBackColor(&rgb_white);

		if (master_port!=port || (*(SInt32*)&master_frame->bottom!=*(SInt32*)&frame->bottom))
			CopyBits((BitMapPtr)*master_port->portPixMap,(BitMapPtr)*port->portPixMap,
				master_frame,frame,ditherCopy,(RgnHandle)NULL);

		SetGWorld(oldport,oldgd);
		if (err=GetMaxCompressionSize(port->portPixMap,frame,0,codecLosslessQuality,
			kAnimationCodecType,(CompressorComponent)anyCodec,&maximum_size))
		{
			dprintf("GetMaxCompressionSize() gave %d", err);
			return err;
		}
		myUnlockPixels(port);

	/* break */
		ticks = machine_tick_count();
		if (U64Gt(&ticks,&last_ticks))
		{
			last_ticks = ticks;
			Add64U32(&last_ticks,30);				/* half a second */
			HandleEvent(NULL,NULL,0,0);
		/* call a second time for background updates */
			if (!(setup&3)) HandleEvent(NULL,NULL,0,0);
		}

		SetHandleSize(data_handle,maximum_size);
		if (err=MemError())
		{
			dprintf("SetHandleSize(%p), MemError() == %d", data_handle,err);
			goto close;
		}
		MoveHHi(data_handle);
		HLock(data_handle);
		myLockPixels(port);
		compressed_data = *data_handle;
		if (err=CompressImage(port->portPixMap,frame,codecLosslessQuality,
			kAnimationCodecType,image_description,compressed_data))
		{
			dprintf("CompressImage() gave %d", err);
			goto close;
		}
		if (err=AddMediaSample(media,data_handle,0,(**image_description).dataSize,
			30,(SampleDescriptionHandle)image_description,1,0,NULL))
		{
			dprintf("AddMediaSample(%p) gave %d", media,err);
			goto close;
		}
		HUnlock(data_handle);
		if (gDone) break;		/* weve been signalled to quit */
	}
close:
	DisposeHandle((Handle)image_description);
data:
	DisposeHandle(data_handle);
	myUnlockPixels(port);
end:
	/*SetPort(wDock); */
	SetCrapBoxText("-Done-");
	if (crap_points) free(crap_points);
	return err;
}

void startup(boolean display);
void startup(boolean display)
{
	StandardFileReply	selected_file;

	Movie		newcrap = (Movie)NULL;
	Track		newtrack;
	Media		newmedia;
	Rect		full_bounds = {0,0,480,640}, bounds = {0,0,240,320};

	GDHandle	oldgd;
	GWorldPtr	oldport, port = NULL;

	short		depth = 16, refNum = 0, new_id = 0, error;
	boolean		movies_entered = FALSE;

	GetGWorld(&oldport,&oldgd);
//Debugger();
	if (error=EnterMovies())
	{
		dprintf("EnterMovies() gave %d", error);
		goto end;
	}
	movies_entered = TRUE;
	if (error=NewGWorld(&port,depth,&full_bounds,(CTabHandle)NULL,(GDHandle)NULL,0))
	{
		dprintf("NewGWorld(%p,%d) gave %d", &full_bounds,error);
		goto end;
	}
	//SetGWorld(port,NULL);
	//myLockPixels(port);
	//PenSize(2,2);
	//SetRawBackColor(0x80999999,_ct_ARGB24 | _ct_aplha_is_opacity);
	SetGWorld(oldport,oldgd);
	//myUnlockPixels(port);

	{
		StandardPutFile(NULL,"\pNew Crap",&selected_file);
		if (!selected_file.sfGood) goto end;
		FSpDelete((FSSpec*)&selected_file.sfFile);
		if (error=CreateMovieFile((FSSpec*)&selected_file.sfFile,'TVOD',0,0,&refNum,&newcrap))
		{
			dprintf("CreateMovieFile(%p) gave %d", &selected_file.sfFile,error);
			goto end;
		}
	}
	//newcrap = NewMovie(newMovieDontAskUnresolvedDataRefs);
	SetMovieBox(newcrap,&bounds);
	newtrack = NewMovieTrack(newcrap,RECT_WIDTH(&bounds)<<16,RECT_HEIGHT(&bounds)<<16,kNoVolume);
	newmedia = NewTrackMedia(newtrack,VideoMediaType,600,(Handle)NULL,0);
	if (error=BeginMediaEdits(newmedia))
	{
		dprintf("BeginMediaEdits(%p) gave %d", newmedia,error);
		goto close;
	}
	GenerateVideoFrames(newmedia,port,port,&full_bounds,&bounds,80,display&&GetWindow(kDockWindow));
	if (error=EndMediaEdits(newmedia)) dprintf("EndMediaEdits(%p) gave %d", newmedia,error);

	if (error=InsertMediaIntoTrack(newtrack,0,0,GetMediaDuration(newmedia),0x10000))
	{
		dprintf("InsertMediaIntoTrack(%p,0,0,GetMediaDuration(%p),0x10000) gave %d", newtrack,newmedia,error);
		goto close;
	}
	if (error=AddMovieResource(newcrap,refNum,&new_id,selected_file.sfFile.name))
		dprintf("AddMovieResource(%d,refNum,%p,%p) gave %d",
			newcrap,&new_id,&selected_file.sfFile.name,error);
close:
	if (error=CloseMovieFile(refNum))
		dprintf("CloseMovieFile(%d) gave %d", refNum,error);
end:
	SetGWorld(oldport,oldgd);
	if (newcrap) DisposeMovie(newcrap);
	if (port) DisposeGWorld(port);
	if (movies_entered) ExitMovies();
}
