
#include "macintosh_cseries.h"

#include "interface.h"
#include "shell.h"

#ifndef __MACMEMORY__
#	include <MacMemory.h>
#endif
#ifndef __QUICKDRAW__
#	include <QuickDraw.h>
#endif
#ifndef __RESOURCES__
#	include <Resources.h>
#endif
#ifndef __STANDARDFILE__
#	include <StandardFile.h>
#endif

#ifndef __MACERRORS__
#	include <MacErrors.h>
#endif

#include "my32bqd.h"

#include "AWCodeX.h"

UInt16		_isqrt_tables[26+64] =
{
	/* BFFFO table (index to first one bit from top) */
	65535, 38968, 27554, 19484, 13777, 9742, 6888, 4871, 3444, 2435, 1722,
	1218, 861, 609, 431, 304, 215, 152, 108, 76, 54, 38, 27, 19, 13, 10,

	/* small table [0,128) -- in bytes */
	0x001,0x102,0x202,0x203,0x303,0x303,0x304,0x404,
	0x404,0x404,0x405,0x505,0x505,0x505,0x505,0x506,
	0x606,0x606,0x606,0x606,0x606,0x607,0x707,0x707,
	0x707,0x707,0x707,0x707,0x708,0x808,0x808,0x808,
	0x808,0x808,0x808,0x808,0x809,0x909,0x909,0x909,
	0x909,0x909,0x909,0x909,0x909,0x90A,0xA0A,0xA0A,
	0xA0A,0xA0A,0xA0A,0xA0A,0xA0A,0xA0A,0xA0A,0xA0B,
	0xB0B,0xB0B,0xB0B,0xB0B,0xB0B,0xB0B,0xB0B,0xB0B
};

#define isqrt(x)		_isqrt(x,_isqrt_tables)

#pragma parameter __D0 _isqrt(__D2,__A0)
extern SInt32 _isqrt(UInt32, void*) =
	{0xEDC2, 25, 0x6608, 0x7000, 0x1030, 0x2034, 0x6012, 0x3030, 0x200, 0x2202,
	0x82C0, 0x680A, 0x4A42, 0x56C1, 0x49C1, 0x9081, 0x602E, 0xD041, 0xE250, 0x2202,
	0x82C0, 60, 16, 0xD141, 0xE250, 0x2202, 0x82C0, 0xD041, 0xE250, 0x2F02,
	0x3F3C, 0x8000, 0x3F00, 0x241F, 0x4C02, 0x2401, 0xB29F, 0x55C1, 0x49C1, 0x9041};
#pragma parameter __D0 _nsqrt(__D2,__A0)
extern SInt32 _nsqrt(UInt32, void*) =
	{0xEDC2, 25, 0x6608, 0x7000, 0x1030, 0x2034, 0x6012, 0x3030, 0x200, 0x2202,
	0x82C0, 0x680A, 0x4A42, 0x56C1, 0x49C1, 0x9081, 0x602E, 0xD041, 0xE250, 0x2202,
	0x82C0, 60, 16, 0xD141, 0xE250, 0x2202, 0x82C0, 0xD041, 0xE250};

typedef struct long_point3d
{
	SInt32		x, y, z;
} long_point3d;

typedef struct view_point//(68)
{
	SInt32		px, py, pz;
	SInt32		ax, ay, az;
	SInt32		sx, sy, sz;
	SInt32		cosx, sinx, cosy, siny, xcosz, xsinz, ycosz, ysinz;
} view_point;

/* transormation */
static Point world_point_to_screen_point(long_point3d *point, view_point *view)
{
	Point				out_point;

	register long		x = point->x-view->px;
	register long		y = point->y-view->py;
	register long		z = point->z-view->pz;
	register long		t = UFix16Mul(13107,17);

	t = NFix30Mul(x,view->cosy)+NFix30Mul(y,view->siny);
	y = NFix30Mul(y,view->cosy)-NFix30Mul(x,view->siny);
	z = NFix16Mul(z,view->sz);
	out_point.h = NFix16Div(NFix16Mul(t,view->xcosz)+NFix16Mul(y,view->xsinz),z);
	out_point.v = NFix16Div(NFix16Mul(y,view->ycosz)-NFix16Mul(t,view->ysinz),z);

	return out_point;
}

#include <Traps.h>

#pragma parameter map_horizontal_lines16(__A0,__A1,__D2)
extern void map_horizontal_lines16(texture_line_data*, void*, UInt32) =
	{0x2F0B, 0x2F0A, 0x2F07, 0x2F06, 0x2F05, 0x2F04, 0x2F03, 0x518F, 0x7000, 0x2C09,
		0x5342, 0x6C02, 0x6040, 0x2258, 0x2E98, 0x2F58, 4, 0x2818, 0x2A18, 0x2446,
		0xD4D8, 0x3618, 0x6C02, 0x6024, 0x3017, 0x1E2F, 4, 0x280, 0, 0x7F00, 0x287,
		0, 0xFE, 0xD997, 0xDBAF, 4, 0xDE80, 0x3030, 0x7800, 0x32C0, 0x51CB, -34, 0xDC81,
		0x51CA, -62, 0x508F, 0x261F, 0x281F, 0x2A1F, 0x2C1F, 0x2E1F, 0x245F, 0x265F};

static void _map_horizontal_lines16(...)
{
#define ROW_BYTES			d1
#define LINE_COUNT			d2
#define COUNT				d3
#define TEXTURE_DX			d4
#define TEXTURE_DY			d5
#define LINE_START			d6

#define HLINE				a0
#define TEXTURE				a1
#define SCREEN				a2

	asm
	{
		move.l		a3,-(sp)
		move.l		a2,-(sp)
		move.l		d7,-(sp)
		move.l		d6,-(sp)
		move.l		d5,-(sp)
		move.l		d4,-(sp)
		move.l		d3,-(sp)
		subq.l		#8,sp
		moveq		#0,d0
		move.l		a1,LINE_START
		subq.w		#1,LINE_COUNT
		bge.s		@next_line
		bra.s		@end
@next_line
		move.l		(HLINE)+,TEXTURE
		move.l		(HLINE)+,(sp)
		move.l		(HLINE)+,4(sp)
		move.l		(HLINE)+,TEXTURE_DX
		move.l		(HLINE)+,TEXTURE_DY
		move.l		LINE_START,SCREEN
		adda.w		(HLINE)+,SCREEN
		move.w		(HLINE)+,COUNT
		bge.s		@pixel
		bra.s		@line
@pixel
		; 13cpp @ 33MHz  2.56 mega-pixels per second
		move.w		(sp),d0					; TEXTURE_X
		move.b		4(sp),d7				; TEXTURE_Y
		andi.l		#0x7F00,d0
		andi.l		#0x00FE,d7
		add.l		TEXTURE_DX,(sp)
		add.l		TEXTURE_DY,4(sp)
		add.l		d0,d7
		move.w		(a0,d7.l),d0
		move.w		d0,(a1)+
		dbf			COUNT,@pixel
@line
		add.l		ROW_BYTES,LINE_START
		dbf			LINE_COUNT,@next_line
@end
		addq.l		#8,sp
		move.l		(sp)+,d3
		move.l		(sp)+,d4
		move.l		(sp)+,d5
		move.l		(sp)+,d6
		move.l		(sp)+,d7
		move.l		(sp)+,a2
		move.l		(sp)+,a3
	}
}

static UInt32	black_wctb[] =
{
	//00000000000000040000FFFFFFFFFFFF0001000000000000000200000000000000030000000000000004FFFFFFFFFFFF
};

void main(AWCodeXParam *param)
{
	struct XPort		port;

	//NewHandle();
	OpenOffscreenCPort(&port);
}
