
#include "macintosh_cseries.h"

#include <AIFF.h>

#include "interface.h"
#include "screen.h"
#include "shell.h"		// strictly for HandleEvent

#include <praxInfinite.h>

static float4b4		crap[] =
{
	{0,4}, {0,8}, {0,16}, {0,25}, {0,27}, {0,36}, {0x7FFFFFFE,625}, {0,64}, {0,81}
};

static struct
{
	ContainerChunk		form;
	FormatVersionChunk	format;
	ExtCommonChunk		common;
	SoundDataChunk		sound;
} AIFFHeader =
{
	{FORMID, -8, AIFFID},
	{FormatVersionID, 4, AIFCVersion1},		/* May 23, 1990 @ 14:40 -- whod knew */
	{CommonID, 0, 0, 0, 0, 4294967295.0, NoneType},
	{SoundDataID, 0, 0, 0}
};

void startup(boolean display);
void startup(boolean display)
{
	SFixed32		fa, fb, fc, fd, fe, fg, af, bf, cf, df, ef, gf;
	UFixed32		fr;
	UInt64			last_ticks, ticks;

	register SInt16		*aptr;
	register UInt32		r, c, d, x;

	UInt32		setup = 1;
	SInt16		*result;

	assert(sizeof(NumVersion)==sizeof(long));
	Debugger();

	*(Float64*)&last_ticks = 0;

	d = 46200*2;
	fr.hi = d, fr.lo = 0;
	result = malloc(d*4);	/* 4 seconds */
	if (!result) goto end;
	aptr = result;

/* quadruple RSine32 controlled wave (very accurate but slow) */

	fa.hi = 0, fa.lo = 0, af.hi = 8000, af.lo = 0;
	fb.hi = 0, fb.lo = 0, bf.hi = 20, bf.lo = 0;
	fc.hi = 0, fc.lo = 0, cf.hi = 7680, cf.lo = 0;
	fd.hi = 0, fd.lo = 0, df.hi = 32, df.lo = 0xA1F37553;
	fe.hi = 0, fe.lo = 0, ef.hi = 6400, ef.lo = 0;
	fg.hi = 0, fg.lo = 0, gf.hi = 22, gf.lo = 0x3210FEDD;
	x = d;
	do
	{
		SAdd64(&fe,&ef);
		Add64S32(&ef,RSine32(fg,fr,0x7AAAAAAB));
		SAdd64(&fg,&gf);
		SAdd64(&fb,&fg);

		*aptr++ = RSine32(fa,fr,0x4000)+RSine32(fc,fr,0x4000);
		SAdd64(&fa,&af);
		Add64S32(&af,RSine32(fb,fr,0x20000000));
		SAdd64(&fb,&bf);

		SAdd64(&fc,&cf);
		Add64S32(&cf,RSine32(fd,fr,0x10000000));
		SAdd64(&fd,&df);
		if (!(x&127))
		{
			if (display)
			{
				++setup;
				sprintf(temporary,"RSine32 Remaining samples: %d", x);
				SetCrapBoxText(temporary);
			}
			ticks = machine_tick_count();
			if (U64Gt(&ticks,&last_ticks))
			{
				last_ticks = ticks;
				Add64U32(&last_ticks,30);				// half a second
				HandleEvent(NULL,NULL,0,0);
			// call a second time for background updates
				if (!(setup&3)) HandleEvent(NULL,NULL,0,0);
			}
		}
	} while(--x);

/* USine16 wave (fastest) */

	d = 0x105A025, r = 0xB4780000, x = UFix16Mul(r,2), c = 0;
	do
	{
		*aptr++ = NFract32Mul(USine16(c,r,-1),0x3FFFF)>>1;
		if ((c+=d)>r) c -= r;
		if (!(x&127))
		{
			if (display)
			{
				++setup;
				sprintf(temporary,"USine16 Remaining samples: %d", x);
				SetCrapBoxText(temporary);
			}
			ticks = machine_tick_count();
			if (U64Gt(&ticks,&last_ticks))
			{
				last_ticks = ticks;
				Add64U32(&last_ticks,30);				// half a second
				HandleEvent(NULL,NULL,0,0);
			// call a second time for background updates
				if (!(setup&3)) HandleEvent(NULL,NULL,0,0);
			}
		}
	} while(--x);

	SetCrapBoxText("-Done-");

	fr.hi /= 2;
	{
		StandardFileReply	selectedFile;

		short		refNum, error;
		long		count, length;

		AIFFHeader.common.numSampleFrames = d,
			*(UFixed32*)(2+(Ptr)&AIFFHeader.common.sampleRate) = fr,
			AIFFHeader.sound.ckSize = 2*d;
		StandardPutFile(NULL,"\pMiddle C 16bit",&selectedFile);
		if (!selectedFile.sfGood) goto end;
		if (error=FSpOpenDF((FSSpec*)&selectedFile.sfFile,0,&refNum))
		{
			dprintf("FSpOpenDF gave %d", error);
			goto end;
		}
		count = sizeof(AIFFHeader);
		FSWrite(refNum,&count,&AIFFHeader);
		count = AIFFHeader.sound.ckSize;
		FSWrite(refNum,&count,result);
		GetFPos(refNum,&length);
		SetFPos(refNum,fsFromStart,4);
		count = 4, length -= 8;
		FSWrite(refNum,&count,&length);
		FSClose(refNum);
	}
end:
	;
}
